<!--suppress ALL -->
<template>
  <div id="app">
    <!-- Status bar overlay for full screen mode (Cordova or PhoneGap) -->
    <f7-statusbar></f7-statusbar>
    <!-- Left Panel with "cover" effect -->
    <f7-panel left cover>
      <f7-view>
        <f7-pages navbar-fixed>
          <f7-page>
            <f7-navbar title="Left Panel"></f7-navbar>
            <f7-block>
              <p>Here comes the left panel text</p>
            </f7-block>
          </f7-page>
        </f7-pages>
      </f7-view>
    </f7-panel>
    <!-- Right Panel with "reveal" effect -->
    <f7-panel right reveal>
      <f7-view>
        <f7-pages navbar-fixed>
          <f7-page>
            <f7-navbar title="Right Panel"></f7-navbar>
            <f7-block>
              <p>Here comes the right panel text</p>
            </f7-block>
          </f7-page>
        </f7-pages>
      </f7-view>
    </f7-panel>
    <!-- Views -->
    <f7-views>
      <!-- Main view-->
      <f7-view main navbar-through toolbar-fixed>
        <!-- For iOS theme we use navbar-through layout so the navbar should be a child of the View -->
        <f7-navbar v-if="$theme.ios" title="Awesome App"></f7-navbar>
        <f7-pages navbar-fixed toolbar-fixed>
          <f7-page>
            <!-- For Material theme we use navbar-fixed layout so the navbar should be a child of the Page -->
            <f7-navbar v-if="$theme.material" title="Awesome App"></f7-navbar>
            <!-- Page content -->

            <f7-list inline-labels no-hairlines-md>
              <f7-list-item>
                <f7-input type="text" placeholder="Add new Todo item..." v-model="newTodoItemTitle" clear-button @change="onNewTodoItemSumbit"></f7-input>
              </f7-list-item>
            </f7-list>

            <f7-list no-hairlines-md>
              <f7-list-item>
                <f7-icon icon="demo-list-icon" slot="media"></f7-icon>
                <f7-label floating>Name</f7-label>
                <f7-input type="text" placeholder="Your name" clear-button></f7-input>
              </f7-list-item>
            </f7-list>

            <f7-block>
              <f7-list form>
                <f7-list-item
                  v-for="todo in todoList"
                  checkbox name="my-checkbox" :value="todo.id" :title="todo.title" :checked="todo.status === 'completed'">
                </f7-list-item>
              </f7-list>
            </f7-block>
            <!-- Buttons to open panels -->
            <f7-grid>
              <f7-col>
                <f7-button open-panel="left">Left Panel</f7-button>
              </f7-col>
              <f7-col>
                <f7-button open-panel="right">Right Panel</f7-button>
              </f7-col>
            </f7-grid>
            <!-- Button to open popup -->
            <f7-button open-popup="#my-popup">Open Popup</f7-button>
          </f7-page>
        </f7-pages>
      </f7-view>
    </f7-views>
    <!-- Popup. All modals should be outside of Views -->
    <f7-popup id="my-popup">
      <f7-view>
        <f7-pages navbar-fixed>
          <f7-page>
            <f7-navbar title="Popup">
              <!-- Link to close popup -->
              <f7-nav-right>
                <f7-link close-popup>Close</f7-link>
              </f7-nav-right>
            </f7-navbar>
            <f7-block>
              <p>Here comes popup text</p>
            </f7-block>
          </f7-page>
        </f7-pages>
      </f7-view>
    </f7-popup>
  </div>
</template>

<script>
import Todo from './model/Todo'
import TodoStatus from './model/TodoStatus'
import apis from './apis';
import { mapState } from 'vuex'

export default {
  name: 'App',
  data() {
    return {
      newTodoItemTitle: ''
    }
  },
  methods: {
    onNewTodoItemSumbit () {
      console.log('Add new todo item: ' + this.newTodoItemTitle);
      const todo = new Todo(Todo.generateNewId(), this.newTodoItemTitle, TodoStatus.PENDING);
      apis.create(todo)
        .then(() => {
          this.$store.commit('addTodoItem', todo);
        })
        .then(() => {
          this.newTodoItemTitle = '';
        });
    },
    refresh() {
      this.$store.dispatch('loadFromRemote');
    }
  },
  created() {
    this.refresh();
  },
  computed: mapState(['todoList'])
};
</script>

<style>
</style>
